/*
 * rfm69_commprot.h
 *
 *  Created on: 29. mars 2018
 *      Author: teig
 */

#ifndef RFM69_COMMPROT_H_
#define RFM69_COMMPROT_H_

// ABOUT MY REMOVING OF ACKing (Akcknowledge)
// RFM69 library
//     The RFM69 library has an ACK_REQUESTED (that a receiver will respect if it's not RF69_BROADCAST_ADDR)
//     and ACK_RECEIVED in CTLBYTE in the payload. Sending a message that requires an ACK
//     On the sender side there is sendWithRetry which sends until an ACK has been received.
//     Then the application has to manually listen to ACK requests on the other side and send back the ACK
//     Sending an ACK then sets bit RF_PACKET2_RXRESTART (RestartRx) in
//     REG_PACKETCONFIG2 (RegPacketConfig2) and sends off the payload. However, the receiver also sends
//     with sendWithRetry and with itself requiring an ACK on every third package! The RFM69 library states
//     that "This way both TX/RX NODE functions are tested on 1 end at the GATEWAY"
// RadioHead library
//     _txHeaderFlags with setHeaderFlags function and a waitAvailableTimeout that wait for a message
//     with timout. I assume this could be used to implement AKCing. However, I see no particular ACK
//     mechanism there
// Semtech SX1231H
//    In chapter AutoModes:
//        Automatic reception of acknowledge (AutoRxAck): Mode = Tx, IntermediateMode = Rx,
//        EnterCondition = PacketSent, ExitCondition = CrcOk
//    The above is all mentioning of any acknowledge in the data manual. So I don't think there is any
//    such mechanism at this level
// All of this was removed on RFM69_DRIVER_VERSION_STR 0.5.6. The ACK concept of RFM69 is not interesting
// since ACK will be designed into a fuller protocol when/if I need it. Also, the RFM59 idea that the sender
// of the ACK actually again checks for a return-ACK every now and then, is mixing of roles and OSI
// level that i don't like. Formally proving that kind of protocol is at best very complicated. Also,
// any such will of course only be parsed when appCRC32 is correct

#define RFM69_DRIVER_VERSION_STR "0.9.39" // Always use "x.y.zz
//        24Sep2020           Moved this into the "module_build_info" file. Continue there.
// 0.9.39 25Mar2019           ALLOW_SESSION_TYPE_TRANS_LIB==2 is new. I_RADIO_ANY_LIB removed
// 0.9.38 22Mar2019           chanend ?c_irq_update replaced NO_IRQ_SEND_LIB
// 0.9.37 22Mar2019           NO_IRQ_SEND_LIB is new
// 0.9.36 21Mar2019 AQU=077   Commit for TEST_VECTOR_WORKS A
// 0.9.35 19Mar2019 AQU=077   TEST_19MAR2019 is 0, see file ..SDS00060.png scope picture and the following files
// 0.9.34 11Mar2019 AQU=065   Fixed VALUE_XSCOPE_IB to make it more general. This code runs
// 0.9.33 10Mar2019 AQU=065g  xscope seems to destroy effect of good code with SPI_MASTER_POS 2. This code runs
// 0.9.32 06Mar2019 AQU=065f  I have found a single register write where removing it removes the error
// 0.9.31 05Mar2019 AQU=065e  RETURNS FROM func_handleSPIInterrupt!
// 0.9.30 05Mar2019 AQU=065d  NEVER RETURNS FROM func_handleSPIInterrupt, BUT FULFILLS LAST STATEMENT OF func_handleSPIInterrupt
//                            See 2019 03 05 C Fails 1.4.48 full detail XScope.xmt
// 0.9.29 05Mar2019           XScope. VALUE_XSCOPE_LIB is new
// 0.9.28 28Feb2019           Working to see what I can do to avoid the deadlock on the i_radio.getAndClearErrorBits call (of any sort)
// 0.9.27 25Feb2019           Now all i_radio-calls include ..iff_asynch versions
// 0.9.26 24Feb2019           CLIENT_WAIT_FOR_RADIO_MAX_MS==16 detects AQU=065-like situation
// 0.9.25 24Feb2019           Syntax of for loop in i_radio.encrypt16_trans1 was wrong!
// 0.9.24 23Feb2019           I_RADIO_ANY_LIB is new (to be able to etsr more by hand in client)
// 0.9.23 22Feb2019           _handleSPIInterrupt_iff_asynch now handleSPIInterrupt_iff_asynch again with &refparames
// 0.9.22 22Feb2019           encrypt16_iff_asynch is new
// 0.9.21 22Feb2019           Now g_radio_log_value works on eXplorerKIT
// 0.9.20 21Feb2019           Synch with RFM69_CLIENT_VERSION_STR "0.8.73"
// 0.9.19 20Feb2019 RFM69=013 Atomicity of GET_SHARED_GLOBAL, action, SET_SHARED_GLOBAL
//                            However, it may have to do with something else since even a timing_transx.radio_log_value++; fails!
//                            Am I touching AQU=065 here?
// 0.9.18 19Feb2019           TRANS_ASYNCH_WRAPPED_LIB now tested and works. But problems with shared log value. Aquarium 1.4.24
// 0.9.17 18Feb2019           param_for_trans1_t now is a union, saves 170 bytes
// 0.9.16 18Feb2019           i_radio.sleep removed. Use setMode with RF69_MODE_SLEEP instead (saves about 200 bytes, 18Feb2019)
// 0.9.15 18Feb2019           Now all interface functions have a _trans1 and _iff_trans1 functions
// 0.9.14 14Feb2019           DEBUG_FOREVER_LOOP_LIB new, .._iff and ..iff_trans1 function made (not all yet, but enough to see _Aquarium work
//                            and detect a DEBUG_FOREVER_LOOP_LIB in a [[combinable]] task. THIS IS SO FANTASTIC!
// 0.9.13 13Feb2019           radio_log_value now returned from do_sessions_trans2to3
// 0.9.12 12Feb2019           Functions are better than macros. set_field_g_radio_log_value for SET_FIELD_SHARED_GLOBAL
// 0.9.11 12Feb2019           New set of macros. Seems rather OK!
// 0.9.10 12Feb2019           GET_SHARED_GLOBAL and SET_SHARED_GLOBAL seems to work
// 0.9.09 11Feb2019           New names and perhaps a fix as well
// 0.9.08 10Feb2019           Common data structure timing_transx_t now used with do_sessions_trans2to3
// 0.9.07 09Feb2019           trans2_timed_out is global
// 0.9.05 09Feb2019           do_sessions_trans2to3 is new
// 0.9.04 07Feb2019 RFM69=012 DEBUG_SHARED_LOG_VALUE_LIB is new. get_radio_log_value and i_radio.get_radio_log_value_ptr are new
// 0.9.03 04Feb2019 RFM69=011 Simulate code after while-select with timerafter
// 0.9.02 03Feb2019 RFM69=010 _USERMAKEFILE_LIB_RFM69_XC_TRANS etc. new
// 0.9.01 02Feb2019 RFM69=009 Make the calls here not-blocking asynch to try to isolate AQU=065
// 0.9.00 28Jan2019           All old interrupt handlers removed. Only one (rename) left: IRQ_interrupt_task. No code change, only names avd comments
// 0.8.16 27Jan2019 RFM69=008 Removing need to for the interface call, building on old IRQ_detect_and_follow_task. IRQ_interrupt_task is new
// 0.8.15 27Jan2019           Last with INITIAL and DELAYED, just storing this code now
// 0.8.15 26Jan2019 RFM69=007 pin_still_high_timeout_allowed in IRQ_detect_and_poll_task_2
// 0.8.13 24Jan2019 RFM69=006 pin_new_high_event_on_hold no conditional
// 0.8.12 24Jan2019           Clean-up some values and don't clear others..
// 0.8.11 23Jan2019           New names in rfm69_xc.h
// 0.8.10 23Jan2019           c_irq_update_e new name to make deadlock situation shown
// 0.8.09 22Jan2019           Naming
// 0.8.08 21Jan2019 RFM69=005 IRQ_detect_and_poll_task is new
// 0.8.07 21Jan2019 RFM69=004 Restoring to before while_pin_high, however time_since_last_change_sec now also sends when low pin also immediately
// 0.8.06 20Jan2019           Testing with while_pin_high
// 0.8.5  14Jan2019           version_of_app_payload_t is new, and concrete value (like VERSION_OF_APP_PAYLOAD_01) moved out of here, to application
// 0.8.4  01Dec2018           messageRadioCRC16AppCRC32Errs_IRQ removed
// 0.8.3  30Nov2018           IRQ_detect_and_follow_task is new, with all that come swith it. So that client can see a stuck IRQ line.
// 0.8.2  28Nov2018           _USERMAKEFILE_LIB_RFM69_XC_SEMANTICS_DO_CRC_ERR_NO_IRQ=0 again
//                  RFM69=003 solved with debug_mode_0_1 with IOF_BUTTON_RIGHT. It went on when this was pressed
// 0.8.1  29Oct2018
//                  RFM69=001 The IRQ line that keeps high after IRQ 7 (messagePacketLenErr_IRQ) is worked on. Testing at the moment
//          ----              This tag is also seen in the _Aquarium_rfm69_client.xc code
// 0.8.0  08Aug2018           This version
// 0.7.0  22May2018           Files xccompat_arduino.xc and xccompat_arduino.h removed. Last commit with them is Commit 3b7ba3b
// 0.6.0  21May2018           (Version not updated)
//                            Published as 2018_05_21_rfm69_library_ported_to_xmos_issue_disclaimer_no_guarantee_oyvind_teig.zip as Commit 3b7ba3b
//                            See http://www.xcore.com/viewtopic.php?f=26&t=6718
// 0.6.0  05May2018           SEMANTICS_DO_LOOP_FOR_RF_IRQFLAGS2_PACKETSENT new
// 0.5.9  30Apr2018           Changed some WAIT_FOR_ from max 1000 to max lower value
//                            debug_print_error was not enabled correctly!
// 0.5.8  28Apr2018           REG_SYNCVALUE2 and setNetwork removed. while_writeReg_readRegExpected also removed
// 0.5.7  28Apr2018           REG_SYNCVALUE1, REG_SYNCVALUE2 had been 0x2D and init.NETWORKID (100) all the time
//                            Changed to 0x55 and 0xAA.
// 0.5.6  24Apr2018           sendACK, REQUESTACK, SENDACK, ACKReceived, ACKRequested and all about ACKing removed.
//                            Full packet_t passed into send and sendFrame and CommHeaderRFM69.PACKETLEN not any more used in parsing on RX side,
//                            only first byte from FIFO. so message_received_too_short_for_IRQ, message_received_FIFO_too_long_for_IRQ and
//                            message_received_DATA_too_long_for_IRQ replaced with messagePacketLenErr_IRQ
//                            Commit fba6582. Used saved: 2136, Code saved: 1512 since Commit a5812c1
// 0.5.5  18Apr2018           This is a long-live number during development
// 0.5.2  01Apr2018           v65 bytes application payload, cleaner coded. After an invalid payload_01 received: expected 12 but got 24 bytes. Helped?
// 0.5.1  28Feb2018           now IRQ goes up and down on sending
//                  RFM69=000 First testing with two boards

//      Provided hard-compiled value to REG_SYNCCONFIG (RegSyncConfig) is RF_SYNC_SIZE_2
#define RFM69_SYNCVALUE1 0x55 // For RegSyncValue1
#define RFM69_SYNCVALUE2 0xAA // For RegSyncValue2. "NETWORKID" was used

// BAUD RATE is hard coded
//     REG_BITRATEMSB (RegBitrateMsb) and REG_BITRATELSB (RegBitrateLsb) are hard coded with
//     RF_BITRATEMSB_55555 and RF_BITRATELSB_55555

// FREQUENCY is hard coded
//     FREQUENCY is hard coded with RF69_433MHZ and programmed into REG_FRFMSB (RegFrfMsb), REG_FRFMID (RegFrfMid)
//     and REG_FRFLSB (RegFrfLsb) with RF_FRFMSB_433, RF_FRFMID_433 and RF_FRFLSB_433

#define MY_KEY "OM11-Aquarium-1" // 15 chars, the 16th is the nul-terminator added by the compiler, which is now part of the key
             // If I make it 16 chars here, then I get this from the compiler:
             //     "warning: initializer-string for array of chars will not include nul terminator [-Wunusual-code]"
             // Has to be same 16 characters/bytes on all nodes, not more not less!

// Standard union with an overlapping byte array just works:
// Making no-trick memcpy possible:
//
// <stdint.h> contains the basic typedefs
typedef uint8_t version_of_app_payload_t;
#define NUM_OF_THIS_APP_PAYLOAD_01 1

// SEMTECH 5.2.2.2. Size The FIFO size is fixed to 66 bytes
//
// SX1231H includes a 66 byte TX/RX FIFO (RF69_MAX_FIFO_LEN_65), however to take advantage
// of the built in AES/CRC there is not that much we can use:
#define MAX_SX1231H_PACKET_LEN 61 // Just for cross-reference check. Search for it
//                             60 is highest when modulo 4 == 0 is required (See appCRC32)

#define PACKET_INIT_VAL32 0x00000000
#define PACKET_INIT_VAL08       0x00

// padding_XY = 32-bit value index X[0..] and byte index Y[0..3]

typedef uint8_t           lenm1_t;  // Length minus 1 as read from or written to FIFO
#define LENM1_LEN (sizeof(lenm1_t)) // Is 1

typedef struct { // RF69_FULL_HEADER_LEN_04 long, RFM69 libary struct
    // 32-bit field 0
    lenm1_t PACKETLEN;
    uint8_t TARGETID;   // DESTID: Starts at IOF_START_OF_CHECKSUM
    uint8_t SENDERID;   //
    uint8_t padding_03; // Was CTLBYTE for use with ACK
} RFM69_comm_header32_t;
//
#define IOF_PACKETLEN_0 0
//
#define RFM69HEADER_LEN08_IS4 (sizeof(RFM69_comm_header32_t))

#define IOF_START_OF_CHECKSUM 1

typedef struct {
    // 32-bit field 1
    uint8_t                  numbytes_of_full_payload; // APPFULLPAYLOAD_LEN
    version_of_app_payload_t version_of_full_payload;  // VERSION_OF_APP_PAYLOAD_01
    uint8_t                  num_of_this_app_payload;  // NUM_OF_THIS_APP_PAYLOAD_01
    uint8_t                  app_padding_13;
} app_heading32_t;

#define APPCRC_LEN CRC32_LEN08 // From rfm69_crc.h

//      REG_PALEVEL (RegPaLevel)
#define APPPPOWERLEVEL_MAX_DBM 31
#define APPPOWERLEVEL_MIN_DBM   0

typedef struct {
    uint8_t               noAccess_arr[RFM69HEADER_LEN08_IS4]; // Not to be used by client (=packet_u3_t)
    // ------------------ APLICATION FIELDS: ---------------------
    // ADD NEW VALUES HERE and the update PACKET_LEN_FACIT
    app_heading32_t       appHeading;        // Just available
    uint8_t               appNODEID;         // Field 2 byte 0
    uint8_t               appPowerLevel_dBm; // Field 2 byte 1. There's always a radio!
    uint8_t               appPadding_22;     // Field 2 byte 2
    uint8_t               appPadding_23;     // Field 2 byte 3
    uint8_t               appPayload_uint8_arr[_USERMAKEFILE_LIB_RFM69_XC_PAYLOAD_LEN08]; // Modulo 4! Value from user makefile is XCC_FLAGS = -D_USERMAKEFILE_PAYLOAD_LEN08
    uint32_t              appSeqCnt; // NEEDED, see below
    // ------------------ All above here are APPCRC_OVER_LEN32 ---
    crc32_t               appCRC32; // NEEDED, see below. Over 32 bits array
    //
    // NEEDED: See largest log at "2018 05 15 A One week of log important data.txt" ("8.5 days log @ 1 per second"):
    //     Commit 47b6b8b
    //     appCRC32:  1 per 56257 messages over 8.5 days with PACKET_LEN08=20 and one packet per second
    //     appSeqCnt: The receiver side lost 4469 messages (there is no ACKing),
    //                seen by an increment of more than 1 of a sequence counter.
    //                Of these it lost two in a row 32 times and 3 in a row 1 time
    // See https://groups.google.com/forum/?utm_source=digest&utm_medium=email%2F#!topic/radiohead-arduino/nhtkTIVM7fM
    //
} packet_u3_t; // PACKET_LEN08, same as..

#define PACKET_LEN08 (sizeof(packet_u3_t))  // For "(sizeof(packet_t))" which is not possible

#ifndef _USERMAKEFILE_LIB_RFM69_XC_PAYLOAD_LEN08
    #error _USERMAKEFILE_LIB_RFM69_XC_PAYLOAD_LEN08 NOT DEFINED // Define in User makefile as XCC_FLAGS
#else
    #define PACKET_LEN_FACIT (20 + _USERMAKEFILE_LIB_RFM69_XC_PAYLOAD_LEN08) // Checking against this for errors. MUST BE MODULO 4! (like 12,16,20..)
#endif // Correct if faulty:  20 == PACKET_LEN08?

//      Word defines. Remember that sizeof(unsigned) is 4!
#define PACKET_LEN32      (PACKET_LEN08/4)              // Division must have zero remainder, so "modulo 4 == 0"
#define APPCRC_LEN32      (CRC32_LEN08/4)               // --"--
#define APPCRC_OVER_LEN32 (PACKET_LEN32 - APPCRC_LEN32) // --"-- CRC32 calculated over all but the last word, where CRC32 is stored

#define APPFULLPAYLOAD_LEN (PACKET_LEN08 - RFM69HEADER_LEN08_IS4)
#define APPNORMPAYLOAD_LEN (PACKET_LEN08 - RFM69HEADER_LEN08_IS4 - CRC32_LEN08)

typedef struct {
    RFM69_comm_header32_t CommHeaderRFM69; // RFM69HEADER_LEN08_IS4, to be used by driver only
    uint8_t               appPayload_uint8_arr [APPNORMPAYLOAD_LEN];
    crc32_t               appCRC32;
} packet_u0_t;

typedef struct {
    union {
        packet_u0_t packet_u0;                          // For driver
        uint8_t     packet_u1_uint8_arr[PACKET_LEN08];  // For driver (ok client for debug_print)
        uint32_t    packet_u2_uint32_arr[PACKET_LEN32]; // For driver (ok client for fast init to all zeroes and for appCRC32)
                                                        // packet_u2_uint32_arr adds the requirement that modulo 4 == 0
        //
        packet_u3_t packet_u3; // For client (except noAccess_arr)
    } u;
} packet_t;

#endif
