/*
 * module_xc_ptr.xc
 *
 *  Copy from xc_ptr.h in module_xc_ptr in sc_util-master, see https://github.com/xcore/sc_util/tree/master/module_xc_ptr
 *  For project _xmos_issues xTIMEcomposer found USED_MODULES = module_xc_ptr
 *  but not for _Aquarium_1_x or _Aquarium_rfm69_client. Therefore I copied them over here, and added "module_" to their names
 *
 */

#include "module_xc_ptr.h"
extern inline xc_ptr array_to_xc_ptr(const char a[]);

// ---------------- TEIG ----------------

#include <xs1.h>
#include <platform.h>  // slice
#include <timer.h>     // delay_milliseconds(200), XS1_TIMER_HZ etc
#include <stdint.h>    // uint8_t
#include <stdio.h>     // debug_print
#include <xccompat.h>  // REFERENCE_PARAM(my_app_ports_t, my_app_ports) -> my_app_ports_t &my_app_ports
#include <iso646.h>    // not etc.
#include <spi.h>

#include "rfm69_globals.h"

#ifndef DEBUG_SHARED_LOG_VALUE_LIB
    #error DEBUG_SHARED_LOG_VALUE_LIB not defined
#elif (DEBUG_SHARED_LOG_VALUE_LIB==1)

    // These function calls save about 500 bytes instead of the inlined macros
    // That is, with 0.9.12 12Feb2019

    //   BITOR_ANYPOS_SHARED_GLOBAL(g_global,bitpos)
    void bitor_anypos_g_radio_log_value (const unsigned bitpos) {
        unsigned value;
        GET_SHARED_GLOBAL(value,g_radio_log_value); // --- Possible race start
        value or_eq (1<<bitpos);                    //     Insert bit into full unsigned
        SET_SHARED_GLOBAL(g_radio_log_value,value); // --- Possible race end
    }

    //   INC_SHARED_GLOBAL(g_global)
    void inc_g_radio_log_value (void) {
        unsigned value;
        GET_SHARED_GLOBAL(value,g_radio_log_value); // --- Possible race start
        value++;                                    //     Increment full unsigned
        SET_SHARED_GLOBAL(g_radio_log_value,value); // --- Possible race end
    }

    //       INC_RIGHT_SHARED_GLOBAL(g_global)
    unsigned inc_right_g_radio_log_value (const unsigned rightmask) { // rightmask: ____________---right---
        unsigned value;
        unsigned work;
        GET_SHARED_GLOBAL(value,g_radio_log_value); // --- Possible race start
        work = value;                               //     Work on a copy
        work++;                                     //     Increment right
        work  and_eq       rightmask;               //     Clear to the left. Wrap-around ok
        value and_eq compl rightmask;               //     Make ready for right bits
        value or_eq        work;                    //     Put right bits in place
        SET_SHARED_GLOBAL(g_radio_log_value,value); // --- Possible race end
        return value;
    }

    //   SET_FIELD_SHARED_GLOBAL(g_global,number)
    void set_field_g_radio_log_value (const unsigned number, const unsigned fieldpos, const unsigned fieldmask) { // fieldmask: _____---field---______
        unsigned value;
        unsigned work;
        work = (number<<fieldpos);                  //     Place number into position
        work and_eq fieldmask;                      //     Clear to the left and to the right. Lost precision ok
        GET_SHARED_GLOBAL(value,g_radio_log_value); // --- Possible race start
        value and_eq compl fieldmask;               //     Make ready for center bits
        value or_eq        work;                    //     Put number<<n in place
        SET_SHARED_GLOBAL(g_radio_log_value,value); // --- Possible race end
    }
#endif

